`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 05.02.2021 14:31:26
// Design Name: 
// Module Name: simple_dual_one_clock
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module simple_dual_Port_1clock #(
            // Width of S_AXI data bus
        parameter integer C_S_AXI_DATA_WIDTH    = 32,
        // Width of S_AXI address bus
        parameter integer C_S_AXI_ADDR_WIDTH    = 18//4
    )(clk,ena,rd_enb,wea,addra,addrb,din,dout);
    
    input clk,ena,rd_enb,wea;
    input [C_S_AXI_ADDR_WIDTH -1:0] addra,addrb;
    input [(C_S_AXI_DATA_WIDTH/4)-1:0] din;
    output reg [(C_S_AXI_DATA_WIDTH/4)-1:0] dout;
    reg [7:0] ram [0:43];
    
    // WRITE
    always @(posedge clk) begin
     if (ena) begin
     if (wea)
     ram[addra] <= din;
     end
    end

    // READ
    always @(posedge clk) begin 
    if (rd_enb)
     dout <= ram[addrb];
    end
   endmodule
